package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketCode;
import com.izouma.awesomeadmin.service.MarketCodeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/marketCode")
public class MarketCodeController {

    @Autowired
    private MarketCodeService marketCodeService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketCode record) {
        List<MarketCode> pp = marketCodeService.getMarketCodeList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getMarketCode", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketCode(@RequestParam(required = false, value = "id") String id) {
        MarketCode data = marketCodeService.getMarketCodeById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketCode record) {
        MarketCode data = marketCodeService.getMarketCode(record);
        return new Result(true, data);
    }

    /**
     * 检测推广码是否存在
     *
     * @param record
     * @return
     */
    @RequestMapping(value = "/check", method = RequestMethod.GET)
    @ResponseBody
    public Result check(MarketCode record) {
        if (StringUtils.isNotEmpty(record.getCode())) {

            MarketCode data = marketCodeService.getMarketCode(record);
            if (data != null) {

                return new Result(true, data);
            }
            return new Result(false, "推广码不存在");
        }
        return new Result(false, "推广码不能为空");
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketCode record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketCode> pp = marketCodeService.getMarketCodeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketCode record) {
        boolean num = marketCodeService.createMarketCode(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketCode(MarketCode record) {
        boolean num = marketCodeService.updateMarketCode(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketCode(MarketCode record) {

        boolean num = marketCodeService.deleteMarketCode(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketCode record) throws Exception {

        List<MarketCode> marketCodes = marketCodeService.getMarketCodeList(record);


        String sheetName = "market_code";
        String titleName = "推广码数据表";
        String fileName = "推广码表";
        int columnNumber = 11;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "推广人", "推广CODE", "类型", "备注", "可以"};
        String[][] dataList = new String[marketCodes.size()][11];

        for (int i = 0; i < marketCodes.size(); i++) {

            dataList[i][0] = String.valueOf(marketCodes.get(i).getId());
            dataList[i][1] = String.valueOf(marketCodes.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(marketCodes.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(marketCodes.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(marketCodes.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(marketCodes.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(marketCodes.get(i).getMarket());
            dataList[i][7] = String.valueOf(marketCodes.get(i).getCode());
            dataList[i][8] = String.valueOf(marketCodes.get(i).getTypeId());
            dataList[i][9] = String.valueOf(marketCodes.get(i).getRemark());
            dataList[i][10] = String.valueOf(marketCodes.get(i).getUseFlag());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

